it-swarm-ru.tech

Шаблоны проектирования или лучшие практики для сценариев Shell

Кто-нибудь знает какие-либо ресурсы, которые рассказывают о передовых методах или шаблонах проектирования для сценариев Shell (sh, bash и т.д.)?

160
user14437

Я написал довольно сложные сценарии оболочки, и мое первое предложение - "не". Причина в том, что довольно легко совершить небольшую ошибку, которая мешает вашему сценарию или даже делает его опасным.

Тем не менее, у меня нет других ресурсов, чтобы передать вас, кроме моего личного опыта. Вот то, что я обычно делаю, это излишне, но имеет тенденцию быть твердым, хотя очень многословно.

Призывание

заставить ваш скрипт принимать длинные и короткие опции. будьте осторожны, потому что есть две команды для разбора опций, getopt и getopts. Используйте getopt, чтобы избежать проблем.

CommandLineOptions__config_file=""
CommandLineOptions__debug_level=""

getopt_results=`getopt -s bash -o c:d:: --long config_file:,debug_level:: -- "[email protected]"`

if test $? != 0
then
    echo "unrecognized option"
    exit 1
fi

eval set -- "$getopt_results"

while true
do
    case "$1" in
        --config_file)
            CommandLineOptions__config_file="$2";
            shift 2;
            ;;
        --debug_level)
            CommandLineOptions__debug_level="$2";
            shift 2;
            ;;
        --)
            shift
            break
            ;;
        *)
            echo "$0: unparseable option $1"
            EXCEPTION=$Main__ParameterException
            EXCEPTION_MSG="unparseable option $1"
            exit 1
            ;;
    esac
done

if test "x$CommandLineOptions__config_file" == "x"
then
    echo "$0: missing config_file parameter"
    EXCEPTION=$Main__ParameterException
    EXCEPTION_MSG="missing config_file parameter"
    exit 1
fi

Другим важным моментом является то, что программа всегда должна возвращать ноль, если завершается успешно, ненулевой, если что-то пошло не так.

Вызовы функций

Вы можете вызывать функции в bash, просто не забудьте определить их перед вызовом. Функции похожи на скрипты, они могут возвращать только числовые значения. Это означает, что вам нужно придумать другую стратегию для возврата строковых значений. Моя стратегия состоит в том, чтобы использовать переменную с именем RESULT для сохранения результата и возвращать 0, если функция выполнена правильно. Кроме того, вы можете вызвать исключения, если вы возвращаете значение, отличное от нуля, и затем установить две "переменные исключения" (мои: EXCEPTION и EXCEPTION_MSG), первая из которых содержит тип исключения, а вторая - сообщение, читаемое человеком.

Когда вы вызываете функцию, параметры функции присваиваются специальным переменным $ 0, $ 1 и т.д. Я предлагаю вам поместить их в более значимые имена. объявите переменные внутри функции как локальные:

function foo {
   local bar="$0"
}

Ситуации, подверженные ошибкам

В bash, если не указано иное, в качестве пустой строки используется неустановленная переменная. Это очень опасно в случае опечатки, так как неправильно введенная переменная не будет сообщена, и она будет оценена как пустая. использование

set -o nounset

чтобы этого не случилось. Будьте осторожны, потому что, если вы сделаете это, программа будет прерываться каждый раз, когда вы оцениваете неопределенную переменную. По этой причине единственный способ проверить, не определена ли переменная, заключается в следующем:

if test "x${foo:-notset}" == "xnotset"
then
    echo "foo not set"
fi

Вы можете объявить переменные только для чтения:

readonly readonly_var="foo"

Модуляризация

Вы можете достичь "Python как" модульности, если вы используете следующий код:

set -o nounset
function getScriptAbsoluteDir {
    # @description used to get the script path
    # @param $1 the script $0 parameter
    local script_invoke_path="$1"
    local cwd=`pwd`

    # absolute path ? if so, the first character is a /
    if test "x${script_invoke_path:0:1}" = 'x/'
    then
        RESULT=`dirname "$script_invoke_path"`
    else
        RESULT=`dirname "$cwd/$script_invoke_path"`
    fi
}

script_invoke_path="$0"
script_name=`basename "$0"`
getScriptAbsoluteDir "$script_invoke_path"
script_absolute_dir=$RESULT

function import() { 
    # @description importer routine to get external functionality.
    # @description the first location searched is the script directory.
    # @description if not found, search the module in the paths contained in $Shell_LIBRARY_PATH environment variable
    # @param $1 the .shinc file to import, without .shinc extension
    module=$1

    if test "x$module" == "x"
    then
        echo "$script_name : Unable to import unspecified module. Dying."
        exit 1
    fi

    if test "x${script_absolute_dir:-notset}" == "xnotset"
    then
        echo "$script_name : Undefined script absolute dir. Did you remove getScriptAbsoluteDir? Dying."
        exit 1
    fi

    if test "x$script_absolute_dir" == "x"
    then
        echo "$script_name : empty script path. Dying."
        exit 1
    fi

    if test -e "$script_absolute_dir/$module.shinc"
    then
        # import from script directory
        . "$script_absolute_dir/$module.shinc"
    Elif test "x${Shell_LIBRARY_PATH:-notset}" != "xnotset"
    then
        # import from the Shell script library path
        # save the separator and use the ':' instead
        local saved_IFS="$IFS"
        IFS=':'
        for path in $Shell_LIBRARY_PATH
        do
            if test -e "$path/$module.shinc"
            then
                . "$path/$module.shinc"
                return
            fi
        done
        # restore the standard separator
        IFS="$saved_IFS"
    fi
    echo "$script_name : Unable to find module $module."
    exit 1
} 

затем вы можете импортировать файлы с расширением .shinc со следующим синтаксисом

импорт "AModule/ModuleFile"

Который будет искать в Shell_LIBRARY_PATH. Поскольку вы всегда импортируете в глобальное пространство имен, не забудьте поставить префикс перед всеми вашими функциями и переменными, иначе вы рискуете столкнуться с именами. Я использую двойное подчеркивание в качестве точки python.

Кроме того, поместите это как первое, что в вашем модуле

# avoid double inclusion
if test "${BashInclude__imported+defined}" == "defined"
then
    return 0
fi
BashInclude__imported=1

Объектно-ориентированное программирование

В bash вы не можете заниматься объектно-ориентированным программированием, если не создадите достаточно сложную систему распределения объектов (я думал об этом. Это выполнимо, но безумно). На практике, однако, вы можете выполнять "Синглтон-ориентированное программирование": у вас есть один экземпляр каждого объекта и только один.

Что я делаю: я определяю объект в модуль (см. Запись модуляризации). Затем я определяю пустые переменные (аналогично переменным-членам), функцию инициализации (конструктор) и функции-члены, как в этом примере кода

# avoid double inclusion
if test "${Table__imported+defined}" == "defined"
then
    return 0
fi
Table__imported=1

readonly Table__NoException=""
readonly Table__ParameterException="Table__ParameterException"
readonly Table__MySqlException="Table__MySqlException"
readonly Table__NotInitializedException="Table__NotInitializedException"
readonly Table__AlreadyInitializedException="Table__AlreadyInitializedException"

# an example for module enum constants, used in the mysql table, in this case
readonly Table__GENDER_MALE="GENDER_MALE"
readonly Table__GENDER_FEMALE="GENDER_FEMALE"

# private: prefixed with p_ (a bash variable cannot start with _)
p_Table__mysql_exec="" # will contain the executed mysql command 

p_Table__initialized=0

function Table__init {
    # @description init the module with the database parameters
    # @param $1 the mysql config file
    # @exception Table__NoException, Table__ParameterException

    EXCEPTION=""
    EXCEPTION_MSG=""
    EXCEPTION_FUNC=""
    RESULT=""

    if test $p_Table__initialized -ne 0
    then
        EXCEPTION=$Table__AlreadyInitializedException   
        EXCEPTION_MSG="module already initialized"
        EXCEPTION_FUNC="$FUNCNAME"
        return 1
    fi


    local config_file="$1"

      # yes, I am aware that I could put default parameters and other niceties, but I am lazy today
      if test "x$config_file" = "x"; then
          EXCEPTION=$Table__ParameterException
          EXCEPTION_MSG="missing parameter config file"
          EXCEPTION_FUNC="$FUNCNAME"
          return 1
      fi


    p_Table__mysql_exec="mysql --defaults-file=$config_file --silent --skip-column-names -e "

    # mark the module as initialized
    p_Table__initialized=1

    EXCEPTION=$Table__NoException
    EXCEPTION_MSG=""
    EXCEPTION_FUNC=""
    return 0

}

function Table__getName() {
    # @description gets the name of the person 
    # @param $1 the row identifier
    # @result the name

    EXCEPTION=""
    EXCEPTION_MSG=""
    EXCEPTION_FUNC=""
    RESULT=""

    if test $p_Table__initialized -eq 0
    then
        EXCEPTION=$Table__NotInitializedException
        EXCEPTION_MSG="module not initialized"
        EXCEPTION_FUNC="$FUNCNAME"
        return 1
    fi

    id=$1

      if test "x$id" = "x"; then
          EXCEPTION=$Table__ParameterException
          EXCEPTION_MSG="missing parameter identifier"
          EXCEPTION_FUNC="$FUNCNAME"
          return 1
      fi

    local name=`$p_Table__mysql_exec "SELECT name FROM table WHERE id = '$id'"`
      if test $? != 0 ; then
        EXCEPTION=$Table__MySqlException
        EXCEPTION_MSG="unable to perform select"
        EXCEPTION_FUNC="$FUNCNAME"
        return 1
      fi

    RESULT=$name
    EXCEPTION=$Table__NoException
    EXCEPTION_MSG=""
    EXCEPTION_FUNC=""
    return 0
}

Сигналы захвата и обработки

Я нашел это полезным для ловли и обработки исключений.

function Main__interruptHandler() {
    # @description signal handler for SIGINT
    echo "SIGINT caught"
    exit
} 
function Main__terminationHandler() { 
    # @description signal handler for SIGTERM
    echo "SIGTERM caught"
    exit
} 
function Main__exitHandler() { 
    # @description signal handler for end of the program (clean or unclean). 
    # probably redundant call, we already call the cleanup in main.
    exit
} 

trap Main__interruptHandler INT
trap Main__terminationHandler TERM
trap Main__exitHandler EXIT

function Main__main() {
    # body
}

# catch signals and exit
trap exit INT TERM EXIT

Main__main "[email protected]"

Советы и подсказки

Если что-то не работает по какой-либо причине, попробуйте изменить порядок кода. Порядок важен и не всегда интуитивно понятен.

даже не рассматривайте возможность работы с tcsh. он не поддерживает функции и вообще ужасен.

Надеюсь, это поможет, хотя, пожалуйста, обратите внимание. Если вам приходится использовать то, что я написал здесь, это означает, что ваша проблема слишком сложна, чтобы ее можно было решить с помощью Shell. используйте другой язык. Я должен был использовать это из-за человеческих факторов и наследия.

211
Stefano Borini

Взгляните на Advanced Bash-Scripting Guide , чтобы узнать больше о скриптах в Shell - не только Bash.

Не слушайте людей, говорящих вам смотреть на другие, возможно, более сложные языки. Если сценарии Shell соответствуют вашим потребностям, используйте это. Вы хотите функциональность, а не фантазии. Новые языки дают ценные новые навыки для вашего резюме, но это не поможет, если у вас есть работа, которую нужно выполнить, и вы уже знаете Shell.

Как уже говорилось, для сценариев Shell не так много "лучших практик" или "шаблонов проектирования". Разные варианты использования имеют разные ориентиры и смещения - как и любой другой язык программирования.

23
jtimberman

Сценарий оболочки - это язык, предназначенный для управления файлами и процессами. Хотя он отлично подходит для этого, он не является языком общего назначения, поэтому всегда старайтесь склеивать логику из существующих утилит, а не воссоздавать новую логику в сценарии Shell.

Помимо этого общего принципа, я собрал некоторые распространенные ошибки сценария Shell .

19
pixelbeat

В этом году (в 2008 году) на OSCON прошла отличная сессия, посвященная именно этой теме: http://assets.en.oreilly.com/1/event/12/Shell%20Scripting%20Craftsmanship%20Presentation%201.pdf

12
Fhoxh

Легко: использовать python вместо сценариев оболочки. Вы получаете почти 100-кратное увеличение читабельности без необходимости усложнять то, что вам не нужно, и сохраняете возможность превращать части вашего скрипта в функции, объекты, постоянные объекты (zodb), распределенные объекты (пиро) почти без каких-либо дополнительный код.

8
Joao S O Bueno

Знайте, когда его использовать. Для быстрых и грязных команд склейки все в порядке. Если вам нужно принять более чем несколько нетривиальных решений, циклы, что угодно, используйте Python, Perl и modularize.

Самая большая проблема с Shell заключается в том, что конечный результат часто выглядит как большой шарик грязи, 4000 линий удара и растущий ... и вы не можете от него избавиться, потому что теперь от этого зависит весь ваш проект. Конечно, это началось в 40 строках прекрасного bash.

8
Paweł Hajdan

используйте set -e, чтобы не пахать вперед после ошибок. Попробуйте сделать его совместимым, не полагаясь на bash, если вы хотите, чтобы он работал на not-linux.

8
user10392

Чтобы найти "лучшие практики", посмотрите, как дистрибутивы Linux (например, Debian) пишут свои init-скрипты (обычно находятся в /etc/init.d).

Большинство из них без "bash-isms" и имеют хорошее разделение параметров конфигурации, библиотечных файлов и исходного форматирования.

Мой личный стиль - написать сценарий master-shellscript, который определяет некоторые переменные по умолчанию, а затем пытается загрузить ("исходный") файл конфигурации, который может содержать новые значения.

Я стараюсь избегать функций, поскольку они имеют тенденцию усложнять сценарий. (Perl был создан для этой цели.)

Чтобы убедиться, что скрипт является переносимым, протестируйте его не только с помощью #!/Bin/sh, но также используйте #!/Bin/ash, #!/Bin/dash и т.д. Вы скоро обнаружите специфичный для Bash код.

7
Willem